window.Gleam.initSearch([{"doc":"amber","title":"amber","content":"# amber\n\n[![Package Version](https://img.shields.io/hexpm/v/amber)](https://hex.pm/packages/amber)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/amber/)\n\n🚧 **This package is a work in progress. Use at your own risk.** 🚧\n\n🦕 [Deno](https://deno.com/) bindings for [Gleam](https://gleam.run/). 🌟\n\n## Installation\n\n```sh\ngleam add amber\n```\n\nAmber only supports the JavaScript target using the Deno runtime.\n\nThe following configuration should be used in your `gleam.toml`.\n\n```toml\ntarget = &quot;javascript&quot;\n\n[javascript]\nruntime = &quot;deno&quot;\n```\n\n## Usage\n\n```gleam\nimport amber/deno\n\npub fn main() {\n  deno.write_text_file_sync(&quot;amber.txt&quot;, &quot;deno bindings for gleam&quot;, [])\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/amber&gt;.\n\n## Contributing\n\n### Prerequisites\n\n- [Deno](https://docs.deno.com/runtime/getting_started/installation/)\n- [Gleam](https://gleam.run/getting-started/installing/)\n- [Just](https://just.systems/man/en/prerequisites.html)\n- [Rebar3](https://rebar3.org/docs/getting-started/)\n- [Watchexec](https://github.com/watchexec/watchexec/tree/main?tab=readme-ov-file#install)\n\n_Tip_: You can install these tools using a version manager like\n[asdf](https://asdf-vm.com/guide/getting-started.html) or\n[mise](https://mise.jdx.dev/getting-started.html), which can read from\n`.tool-versions`.\n\n### Initial Setup\n\n```sh\njust\n```\n\n### Development\n\n```sh\njust watch build test\n```\n","url":"index.html"},{"doc":"amber/deno/dir_entry","title":"DirEntry","content":"pub type DirEntry {\n  DirEntry(\n    name: String,\n    is_file: Bool,\n    is_directory: Bool,\n    is_symlink: Bool,\n  )\n}\n Information about a directory entry returned from\n [`deno.read_dir_sync`](../deno.html#read_dir_sync).\n\nDirEntry(\n  name: String,\n  is_file: Bool,\n  is_directory: Bool,\n  is_symlink: Bool,\n)\n\nname\n&lt;p&gt;The file name of the entry. It is just the entity name and does not\ninclude the full path.&lt;/p&gt;\n\nis_file\n&lt;p&gt;True if this is info for a regular file. Mutually exclusive to\n&lt;code&gt;DirEntry.is_directory&lt;/code&gt; and &lt;code&gt;DirEntry.is_symlink&lt;/code&gt;.&lt;/p&gt;\n\nis_directory\n&lt;p&gt;True if this is info for a regular directory. Mutually exclusive to\n&lt;code&gt;DirEntry.is_file&lt;/code&gt; and &lt;code&gt;DirEntry.is_symlink&lt;/code&gt;.&lt;/p&gt;\n\nis_symlink\n&lt;p&gt;True if this is info for a symlink. Mutually exclusive to\n&lt;code&gt;DirEntry.is_file&lt;/code&gt; and &lt;code&gt;DirEntry.is_directory&lt;/code&gt;.&lt;/p&gt;\n\nSynonyms:\namber/deno/dir_entry.DirEntry\namber/deno/dir_entry DirEntry","url":"amber/deno/dir_entry.html#DirEntry"},{"doc":"amber/deno/dir_entry","title":"amber/deno/dir_entry","content":"","url":"amber/deno/dir_entry.html"},{"doc":"amber/deno/error","title":"Error","content":"pub type Error {\n  AddrInUse\n  AddrNotAvailable\n  AlreadyExists\n  BadResource\n  BrokenPipe\n  Busy\n  ConnectionAborted\n  ConnectionRefused\n  ConnectionReset\n  FilesystemLoop\n  Http\n  Interrupted\n  InvalidData\n  IsADirectory\n  NetworkUnreachable\n  NotADirectory\n  NotCapable\n  NotConnected\n  NotFound\n  NotSupported\n  PermissionDenied\n  TimedOut\n  UnexpectedEof\n  WouldBlock\n  WriteZero\n  Other(String)\n}\n\nAddrInUse\n Raised when attempting to open a server listener on an address and port\n that already has a listener.\n\n\nAddrNotAvailable\n Raised when the underlying operating system reports an EADDRNOTAVAIL\n error.\n\n\nAlreadyExists\n Raised when trying to create a resource, like a file, that already exists.\n\n\nBadResource\n The underlying IO resource is invalid or closed, and so the operation\n could not be performed.\n\n\nBrokenPipe\n Raised when trying to write to a resource and a broken pipe error occurs.\n This can happen when trying to write directly to stdout or stderr\n and the operating system is unable to pipe the output for a reason\n external to the Deno runtime.\n\n\nBusy\n Raised when the underlying IO resource is not available because it is\n being awaited on in another block of code.\n\n\nConnectionAborted\n Raised when the underlying operating system reports an ECONNABORTED\n error.\n\n\nConnectionRefused\n Raised when the underlying operating system reports that a connection to\n a resource is refused.\n\n\nConnectionReset\n Raised when the underlying operating system reports that a connection has\n been reset. With network servers, it can be a normal occurrence where a\n client will abort a connection instead of properly shutting it down.\n\n\nFilesystemLoop\n Raised when too many symbolic links were encountered when resolving the\n filename.\n\n\nHttp\n Raised in situations where when attempting to load a dynamic import,\n too many redirects were encountered.\n\n\nInterrupted\n Raised when the underlying operating system reports an EINTR error. In\n many cases, this underlying IO error will be handled internally within\n Deno, or result in an @{link BadResource} error instead.\n\n\nInvalidData\n Raised when an operation to returns data that is invalid for the\n operation being performed.\n\n\nIsADirectory\n Raised when trying to open, create or write to a directory.\n\n\nNetworkUnreachable\n Raised when performing a socket operation but the remote host is\n not reachable.\n\n\nNotADirectory\n Raised when trying to perform an operation on a path that is not a\n directory, when directory is required.\n\n\nNotCapable\n Raised when trying to perform an operation while the relevant Deno\n permission (like --allow-read) has not been granted.\n\n\nNotConnected\n Raised when the underlying operating system reports an ENOTCONN error.\n\n\nNotFound\n Raised when the underlying operating system indicates that the file\n was not found.\n\n\nNotSupported\n Raised when the underlying Deno API is asked to perform a function that\n is not currently supported.\n\n\nPermissionDenied\n Raised when the underlying operating system indicates the current user\n which the Deno process is running under does not have the appropriate\n permissions to a file or resource.\n\n\nTimedOut\n Raised when the underlying operating system reports that an I/O operation\n has timed out (ETIMEDOUT).\n\n\nUnexpectedEof\n Raised when attempting to read bytes from a resource, but the EOF was\n unexpectedly encountered.\n\n\nWouldBlock\n Raised when the underlying operating system would need to block to\n complete but an asynchronous (non-blocking) API is used.\n\n\nWriteZero\n Raised when expecting to write to a IO buffer resulted in zero bytes\n being written.\n\n\nOther(String)\n\n\nSynonyms:\namber/deno/error.Error\namber/deno/error Error","url":"amber/deno/error.html#Error"},{"doc":"amber/deno/error","title":"amber/deno/error","content":"","url":"amber/deno/error.html"},{"doc":"amber/web","title":"AbortSignal","content":"pub type AbortSignal\n\n\nSynonyms:\namber/web.AbortSignal\namber/web AbortSignal","url":"amber/web.html#AbortSignal"},{"doc":"amber/web","title":"Date","content":"pub type Date\n\n\nSynonyms:\namber/web.Date\namber/web Date","url":"amber/web.html#Date"},{"doc":"amber/web","title":"ReadableStream","content":"pub type ReadableStream(r)\n\n\nSynonyms:\namber/web.ReadableStream\namber/web ReadableStream","url":"amber/web.html#ReadableStream"},{"doc":"amber/web","title":"WritableStream","content":"pub type WritableStream(w)\n\n\nSynonyms:\namber/web.WritableStream\namber/web WritableStream","url":"amber/web.html#WritableStream"},{"doc":"amber/web","title":"clear_timeout","content":"pub fn clear_timeout(id: Int) -&gt; Nil\n Cancels a scheduled action initiated by `set_timeout`.\n\n ## Examples\n\n \n let id = web.set_timeout(500, fn() { io.println(&quot;hello&quot;) })\n // ...\n web.clear_timeout(id)\n \n\nSynonyms:\namber/web.clear_timeout\namber/web clear_timeout","url":"amber/web.html#clear_timeout"},{"doc":"amber/web","title":"set_timeout","content":"pub fn set_timeout(delay: Int, callback: fn() -&gt; Nil) -&gt; Int\n Sets a timer which executes a function once after the delay\n (in milliseconds) elapses. Returns an id which may be used to cancel the\n timeout.\n\n ## Examples\n\n \n web.set_timeout(500, fn() { io.println(&quot;hello&quot;) })\n \n\nSynonyms:\namber/web.set_timeout\namber/web set_timeout","url":"amber/web.html#set_timeout"},{"doc":"amber/web","title":"amber/web","content":"","url":"amber/web.html"},{"doc":"amber/deno/file_info","title":"FileInfo","content":"pub type FileInfo {\n  FileInfo(\n    is_file: Bool,\n    is_directory: Bool,\n    is_symlink: Bool,\n    size: Int,\n    mtime: Option(Date),\n    atime: Option(Date),\n    birthtime: Option(Date),\n    dev: Int,\n    ino: Option(Int),\n    mode: Option(Int),\n    nlink: Option(Int),\n    uid: Option(Int),\n    gid: Option(Int),\n    rdev: Option(Int),\n    blksize: Option(Int),\n    blocks: Option(Int),\n    is_block_device: Option(Bool),\n    is_char_device: Option(Bool),\n    is_fifo: Option(Bool),\n    is_socket: Option(Bool),\n  )\n}\n Provides information about a file and is returned by\n [`deno.stat_sync`](../deno.html#stat_sync) and\n [`deno.lstat_sync`](../deno.html#lstat_sync) or from calling\n [`stat_sync`](./fs_file.html#stat_sync) with a\n [`FsFile`](./fs_file.html#FsFile) instance.\n\nFileInfo(\n  is_file: Bool,\n  is_directory: Bool,\n  is_symlink: Bool,\n  size: Int,\n  mtime: Option(Date),\n  atime: Option(Date),\n  birthtime: Option(Date),\n  dev: Int,\n  ino: Option(Int),\n  mode: Option(Int),\n  nlink: Option(Int),\n  uid: Option(Int),\n  gid: Option(Int),\n  rdev: Option(Int),\n  blksize: Option(Int),\n  blocks: Option(Int),\n  is_block_device: Option(Bool),\n  is_char_device: Option(Bool),\n  is_fifo: Option(Bool),\n  is_socket: Option(Bool),\n)\n\nis_file\n&lt;p&gt;True if this is info for a regular file. Mutually exclusive to\n&lt;code&gt;FileInfo.is_directory&lt;/code&gt; and &lt;code&gt;FileInfo.is_symlink&lt;/code&gt;.&lt;/p&gt;\n\nis_directory\n&lt;p&gt;True if this is info for a regular directory. Mutually exclusive to\n&lt;code&gt;FileInfo.is_file&lt;/code&gt; and &lt;code&gt;FileInfo.is_symlink&lt;/code&gt;.&lt;/p&gt;\n\nis_symlink\n&lt;p&gt;True if this is info for a symlink. Mutually exclusive to\n&lt;code&gt;FileInfo.is_file&lt;/code&gt; and &lt;code&gt;FileInfo.is_directory&lt;/code&gt;.&lt;/p&gt;\n\nsize\n&lt;p&gt;The size of the file, in bytes.&lt;/p&gt;\n\nmtime\n&lt;p&gt;The last modification time of the file. This corresponds to the &lt;code&gt;mtime&lt;/code&gt;\nfield from &lt;code&gt;stat&lt;/code&gt; on Linux/Mac OS and &lt;code&gt;ftLastWriteTime&lt;/code&gt; on Windows. This\nmay not be available on all platforms.&lt;/p&gt;\n\natime\n&lt;p&gt;The last access time of the file. This corresponds to the &lt;code&gt;atime&lt;/code&gt;\nfield from &lt;code&gt;stat&lt;/code&gt; on Unix and &lt;code&gt;ftLastAccessTime&lt;/code&gt; on Windows. This may not\nbe available on all platforms.&lt;/p&gt;\n\nbirthtime\n&lt;p&gt;The creation time of the file. This corresponds to the &lt;code&gt;birthtime&lt;/code&gt;\nfield from &lt;code&gt;stat&lt;/code&gt; on Mac/BSD and &lt;code&gt;ftCreationTime&lt;/code&gt; on Windows. This may\nnot be available on all platforms.&lt;/p&gt;\n\ndev\n&lt;p&gt;ID of the device containing the file.&lt;/p&gt;\n\nino\n&lt;p&gt;Inode number.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nmode\n&lt;p&gt;The underlying raw &lt;code&gt;st_mode&lt;/code&gt; bits that contain the standard Unix\npermissions for this file/directory.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nnlink\n&lt;p&gt;Number of hard links pointing to this file.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nuid\n&lt;p&gt;User ID of the owner of this file.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\ngid\n&lt;p&gt;Group ID of the owner of this file.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nrdev\n&lt;p&gt;Device ID of this file.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nblksize\n&lt;p&gt;Blocksize for filesystem I/O.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nblocks\n&lt;p&gt;Number of blocks allocated to the file, in 512-byte units.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nis_block_device\n&lt;p&gt;True if this is info for a block device.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nis_char_device\n&lt;p&gt;True if this is info for a char device.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nis_fifo\n&lt;p&gt;True if this is info for a fifo.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nis_socket\n&lt;p&gt;True if this is info for a socket.&lt;/p&gt;\n&lt;p&gt;&lt;em&gt;Linux/Mac OS only.&lt;/em&gt;&lt;/p&gt;\n\nSynonyms:\namber/deno/file_info.FileInfo\namber/deno/file_info FileInfo","url":"amber/deno/file_info.html#FileInfo"},{"doc":"amber/deno/file_info","title":"amber/deno/file_info","content":"","url":"amber/deno/file_info.html"},{"doc":"amber/deno/bytes_read","title":"BytesRead","content":"pub type BytesRead {\n  Bytes(Int)\n  EOF\n}\n\nBytes(Int)\n\n\nEOF\n\n\nSynonyms:\namber/deno/bytes_read.BytesRead\namber/deno/bytes_read BytesRead","url":"amber/deno/bytes_read.html#BytesRead"},{"doc":"amber/deno/bytes_read","title":"amber/deno/bytes_read","content":"","url":"amber/deno/bytes_read.html"},{"doc":"amber/deno/seek_mode","title":"SeekMode","content":"pub type SeekMode {\n  Start\n  Current\n  End\n}\n\nStart\n\n\nCurrent\n\n\nEnd\n\n\nSynonyms:\namber/deno/seek_mode.SeekMode\namber/deno/seek_mode SeekMode","url":"amber/deno/seek_mode.html#SeekMode"},{"doc":"amber/deno/seek_mode","title":"amber/deno/seek_mode","content":"","url":"amber/deno/seek_mode.html"},{"doc":"amber/deno/set_raw","title":"SetRawOption","content":"pub type SetRawOption {\n  Cbreak(Bool)\n}\n\nCbreak(Bool)\n\n\nSynonyms:\namber/deno/set_raw.SetRawOption\namber/deno/set_raw SetRawOption","url":"amber/deno/set_raw.html#SetRawOption"},{"doc":"amber/deno/set_raw","title":"amber/deno/set_raw","content":"","url":"amber/deno/set_raw.html"},{"doc":"amber/web/array_buffer","title":"ArrayBuffer","content":"pub type ArrayBuffer\n Represents a raw buffer of binary data, which is used to store data for the\n different typed arrays. ArrayBuffers cannot be read from or written to\n directly, but can be passed to a typed array or DataView Object to interpret\n the raw buffer as needed.\n\n\nSynonyms:\namber/web/array_buffer.ArrayBuffer\namber/web/array_buffer ArrayBuffer","url":"amber/web/array_buffer.html#ArrayBuffer"},{"doc":"amber/web/array_buffer","title":"byte_length","content":"pub fn byte_length(array_buffer: ArrayBuffer) -&gt; Int\n The length of the ArrayBuffer (in bytes).\n\nSynonyms:\namber/web/array_buffer.byte_length\namber/web/array_buffer byte_length","url":"amber/web/array_buffer.html#byte_length"},{"doc":"amber/web/array_buffer","title":"new","content":"pub fn new(byte_length: Int) -&gt; ArrayBuffer\n\nSynonyms:\namber/web/array_buffer.new\namber/web/array_buffer new","url":"amber/web/array_buffer.html#new"},{"doc":"amber/web/array_buffer","title":"slice","content":"pub fn slice(\n  array_buffer: ArrayBuffer,\n  begin: Int,\n) -&gt; ArrayBuffer\n\nSynonyms:\namber/web/array_buffer.slice\namber/web/array_buffer slice","url":"amber/web/array_buffer.html#slice"},{"doc":"amber/web/array_buffer","title":"slice_with_end","content":"pub fn slice_with_end(\n  array_buffer: ArrayBuffer,\n  begin: Int,\n  end: Int,\n) -&gt; ArrayBuffer\n\nSynonyms:\namber/web/array_buffer.slice_with_end\namber/web/array_buffer slice_with_end","url":"amber/web/array_buffer.html#slice_with_end"},{"doc":"amber/web/array_buffer","title":"amber/web/array_buffer","content":"","url":"amber/web/array_buffer.html"},{"doc":"amber/web/uint8_array","title":"Uint8Array","content":"pub type Uint8Array\n A typed array of 8-bit unsigned integer values. The contents are initialized\n to 0. If the requested number of bytes could not be allocated an exception\n is raised.\n\n\nSynonyms:\namber/web/uint8_array.Uint8Array\namber/web/uint8_array Uint8Array","url":"amber/web/uint8_array.html#Uint8Array"},{"doc":"amber/web/uint8_array","title":"buffer","content":"pub fn buffer(uint8_array: Uint8Array) -&gt; ArrayBuffer\n\nSynonyms:\namber/web/uint8_array.buffer\namber/web/uint8_array buffer","url":"amber/web/uint8_array.html#buffer"},{"doc":"amber/web/uint8_array","title":"byte_length","content":"pub fn byte_length(uint8_array: Uint8Array) -&gt; Int\n\nSynonyms:\namber/web/uint8_array.byte_length\namber/web/uint8_array byte_length","url":"amber/web/uint8_array.html#byte_length"},{"doc":"amber/web/uint8_array","title":"byte_offset","content":"pub fn byte_offset(uint8_array: Uint8Array) -&gt; Int\n\nSynonyms:\namber/web/uint8_array.byte_offset\namber/web/uint8_array byte_offset","url":"amber/web/uint8_array.html#byte_offset"},{"doc":"amber/web/uint8_array","title":"from_length","content":"pub fn from_length(length: Int) -&gt; Uint8Array\n\nSynonyms:\namber/web/uint8_array.from_length\namber/web/uint8_array from_length","url":"amber/web/uint8_array.html#from_length"},{"doc":"amber/web/uint8_array","title":"from_list","content":"pub fn from_list(list: List(Int)) -&gt; Uint8Array\n\nSynonyms:\namber/web/uint8_array.from_list\namber/web/uint8_array from_list","url":"amber/web/uint8_array.html#from_list"},{"doc":"amber/web/uint8_array","title":"new","content":"pub fn new() -&gt; Uint8Array\n\nSynonyms:\namber/web/uint8_array.new\namber/web/uint8_array new","url":"amber/web/uint8_array.html#new"},{"doc":"amber/web/uint8_array","title":"amber/web/uint8_array","content":"","url":"amber/web/uint8_array.html"},{"doc":"amber/deno/fs_file","title":"FsFile","content":"pub type FsFile\n\n\nSynonyms:\namber/deno/fs_file.FsFile\namber/deno/fs_file FsFile","url":"amber/deno/fs_file.html#FsFile"},{"doc":"amber/deno/fs_file","title":"close","content":"pub fn close(file: FsFile) -&gt; Nil\n\nSynonyms:\namber/deno/fs_file.close\namber/deno/fs_file close","url":"amber/deno/fs_file.html#close"},{"doc":"amber/deno/fs_file","title":"is_terminal","content":"pub fn is_terminal(file: FsFile) -&gt; Bool\n\nSynonyms:\namber/deno/fs_file.is_terminal\namber/deno/fs_file is_terminal","url":"amber/deno/fs_file.html#is_terminal"},{"doc":"amber/deno/fs_file","title":"lock_sync","content":"pub fn lock_sync(file: FsFile, exclusive: Bool) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.lock_sync\namber/deno/fs_file lock_sync","url":"amber/deno/fs_file.html#lock_sync"},{"doc":"amber/deno/fs_file","title":"read_sync","content":"pub fn read_sync(\n  file: FsFile,\n  p: Uint8Array,\n) -&gt; Result(BytesRead, Error)\n\nSynonyms:\namber/deno/fs_file.read_sync\namber/deno/fs_file read_sync","url":"amber/deno/fs_file.html#read_sync"},{"doc":"amber/deno/fs_file","title":"readable","content":"pub fn readable(file: FsFile) -&gt; ReadableStream(Uint8Array)\n\nSynonyms:\namber/deno/fs_file.readable\namber/deno/fs_file readable","url":"amber/deno/fs_file.html#readable"},{"doc":"amber/deno/fs_file","title":"seek_sync","content":"pub fn seek_sync(\n  file: FsFile,\n  offset: Int,\n  whence: SeekMode,\n) -&gt; Int\n\nSynonyms:\namber/deno/fs_file.seek_sync\namber/deno/fs_file seek_sync","url":"amber/deno/fs_file.html#seek_sync"},{"doc":"amber/deno/fs_file","title":"set_raw","content":"pub fn set_raw(\n  file: FsFile,\n  mode: Bool,\n  options: List(SetRawOption),\n) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.set_raw\namber/deno/fs_file set_raw","url":"amber/deno/fs_file.html#set_raw"},{"doc":"amber/deno/fs_file","title":"stat_sync","content":"pub fn stat_sync(file: FsFile) -&gt; Result(FileInfo, Error)\n\nSynonyms:\namber/deno/fs_file.stat_sync\namber/deno/fs_file stat_sync","url":"amber/deno/fs_file.html#stat_sync"},{"doc":"amber/deno/fs_file","title":"sync_data_sync","content":"pub fn sync_data_sync(file: FsFile) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.sync_data_sync\namber/deno/fs_file sync_data_sync","url":"amber/deno/fs_file.html#sync_data_sync"},{"doc":"amber/deno/fs_file","title":"sync_sync","content":"pub fn sync_sync(file: FsFile) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.sync_sync\namber/deno/fs_file sync_sync","url":"amber/deno/fs_file.html#sync_sync"},{"doc":"amber/deno/fs_file","title":"truncate_sync","content":"pub fn truncate_sync(file: FsFile) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.truncate_sync\namber/deno/fs_file truncate_sync","url":"amber/deno/fs_file.html#truncate_sync"},{"doc":"amber/deno/fs_file","title":"truncate_to_length_sync","content":"pub fn truncate_to_length_sync(file: FsFile, len: Int) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.truncate_to_length_sync\namber/deno/fs_file truncate_to_length_sync","url":"amber/deno/fs_file.html#truncate_to_length_sync"},{"doc":"amber/deno/fs_file","title":"unlock_sync","content":"pub fn unlock_sync(file: FsFile) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.unlock_sync\namber/deno/fs_file unlock_sync","url":"amber/deno/fs_file.html#unlock_sync"},{"doc":"amber/deno/fs_file","title":"using","content":"pub fn using(\n  file_result: Result(FsFile, Error),\n  fun: fn(FsFile) -&gt; Result(a, Error),\n) -&gt; Result(a, Error)\n\nSynonyms:\namber/deno/fs_file.using\namber/deno/fs_file using","url":"amber/deno/fs_file.html#using"},{"doc":"amber/deno/fs_file","title":"utime_sync","content":"pub fn utime_sync(file: FsFile, atime: Int, mtime: Int) -&gt; FsFile\n\nSynonyms:\namber/deno/fs_file.utime_sync\namber/deno/fs_file utime_sync","url":"amber/deno/fs_file.html#utime_sync"},{"doc":"amber/deno/fs_file","title":"writable","content":"pub fn writable(file: FsFile) -&gt; WritableStream(Uint8Array)\n\nSynonyms:\namber/deno/fs_file.writable\namber/deno/fs_file writable","url":"amber/deno/fs_file.html#writable"},{"doc":"amber/deno/fs_file","title":"write_sync","content":"pub fn write_sync(\n  file: FsFile,\n  p: Uint8Array,\n) -&gt; Result(Int, Error)\n\nSynonyms:\namber/deno/fs_file.write_sync\namber/deno/fs_file write_sync","url":"amber/deno/fs_file.html#write_sync"},{"doc":"amber/deno/fs_file","title":"amber/deno/fs_file","content":"","url":"amber/deno/fs_file.html"},{"doc":"amber/deno/fs_event","title":"FsEvent","content":"pub type FsEvent {\n  FsEvent(\n    kind: FsEventKind,\n    paths: List(String),\n    flag: Option(FsEventFlag),\n  )\n}\n Represents a unique file system event yielded by a\n [`FsWatcher`](./fs_watcher.html#FsWatcher).\n\nFsEvent(\n  kind: FsEventKind,\n  paths: List(String),\n  flag: Option(FsEventFlag),\n)\n\nkind\n&lt;p&gt;The kind/type of the file system event.&lt;/p&gt;\n\npaths\n&lt;p&gt;An array of paths that are associated with the file system event.&lt;/p&gt;\n\nflag\n&lt;p&gt;Any additional flags associated with the event.&lt;/p&gt;\n\nSynonyms:\namber/deno/fs_event.FsEvent\namber/deno/fs_event FsEvent","url":"amber/deno/fs_event.html#FsEvent"},{"doc":"amber/deno/fs_event","title":"FsEventFlag","content":"pub type FsEventFlag {\n  Rescan\n}\n Additional information for FsEvent objects with the &quot;other&quot; kind.\n\n - `&quot;rescan&quot;`: rescan notices indicate either a lapse in the events or a\n    change in the filesystem such that events received so far can no longer\n    be relied on to represent the state of the filesystem now. An\n    application that simply reacts to file changes may not care about this.\n    An application that keeps an in-memory representation of the filesystem\n    will need to care, and will need to refresh that representation directly\n    from the filesystem.\n\nRescan\n\n\nSynonyms:\namber/deno/fs_event.FsEventFlag\namber/deno/fs_event FsEventFlag","url":"amber/deno/fs_event.html#FsEventFlag"},{"doc":"amber/deno/fs_event","title":"FsEventKind","content":"pub type FsEventKind {\n  Any\n  Access\n  Create\n  Modify\n  Rename\n  Remove\n  Other\n}\n\nAny\n\n\nAccess\n\n\nCreate\n\n\nModify\n\n\nRename\n\n\nRemove\n\n\nOther\n\n\nSynonyms:\namber/deno/fs_event.FsEventKind\namber/deno/fs_event FsEventKind","url":"amber/deno/fs_event.html#FsEventKind"},{"doc":"amber/deno/fs_event","title":"amber/deno/fs_event","content":"","url":"amber/deno/fs_event.html"},{"doc":"amber/deno/fs_watcher","title":"FsWatcher","content":"pub type FsWatcher\n\n\nSynonyms:\namber/deno/fs_watcher.FsWatcher\namber/deno/fs_watcher FsWatcher","url":"amber/deno/fs_watcher.html#FsWatcher"},{"doc":"amber/deno/fs_watcher","title":"close","content":"pub fn close(watcher: FsWatcher) -&gt; Nil\n\nSynonyms:\namber/deno/fs_watcher.close\namber/deno/fs_watcher close","url":"amber/deno/fs_watcher.html#close"},{"doc":"amber/deno/fs_watcher","title":"iterate_async","content":"pub fn iterate_async(\n  watcher: FsWatcher,\n  callback: fn(FsEvent) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\namber/deno/fs_watcher.iterate_async\namber/deno/fs_watcher iterate_async","url":"amber/deno/fs_watcher.html#iterate_async"},{"doc":"amber/deno/fs_watcher","title":"amber/deno/fs_watcher","content":"","url":"amber/deno/fs_watcher.html"},{"doc":"amber/deno/make_temp","title":"MakeTempOption","content":"pub type MakeTempOption {\n  Dir(String)\n  Prefix(String)\n  Suffix(String)\n}\n\nDir(String)\n\n\nPrefix(String)\n\n\nSuffix(String)\n\n\nSynonyms:\namber/deno/make_temp.MakeTempOption\namber/deno/make_temp MakeTempOption","url":"amber/deno/make_temp.html#MakeTempOption"},{"doc":"amber/deno/make_temp","title":"amber/deno/make_temp","content":"","url":"amber/deno/make_temp.html"},{"doc":"amber/deno/mkdir","title":"MkdirOption","content":"pub type MkdirOption {\n  Recursive\n  Mode(Int)\n}\n\nRecursive\n\n\nMode(Int)\n\n\nSynonyms:\namber/deno/mkdir.MkdirOption\namber/deno/mkdir MkdirOption","url":"amber/deno/mkdir.html#MkdirOption"},{"doc":"amber/deno/mkdir","title":"amber/deno/mkdir","content":"","url":"amber/deno/mkdir.html"},{"doc":"amber/deno/open","title":"OpenOption","content":"pub type OpenOption {\n  Read\n  Write\n  Append\n  Truncate\n  Create\n  CreateNew\n  Mode(Int)\n}\n\nRead\n\n\nWrite\n\n\nAppend\n\n\nTruncate\n\n\nCreate\n\n\nCreateNew\n\n\nMode(Int)\n\n\nSynonyms:\namber/deno/open.OpenOption\namber/deno/open OpenOption","url":"amber/deno/open.html#OpenOption"},{"doc":"amber/deno/open","title":"amber/deno/open","content":"","url":"amber/deno/open.html"},{"doc":"amber/deno/remove","title":"RemoveOption","content":"pub type RemoveOption {\n  Recursive\n}\n\nRecursive\n\n\nSynonyms:\namber/deno/remove.RemoveOption\namber/deno/remove RemoveOption","url":"amber/deno/remove.html#RemoveOption"},{"doc":"amber/deno/remove","title":"amber/deno/remove","content":"","url":"amber/deno/remove.html"},{"doc":"amber/deno/symlink","title":"SymlinkOption","content":"pub type SymlinkOption {\n  Type(SymlinkType)\n}\n\nType(SymlinkType)\n\n\nSynonyms:\namber/deno/symlink.SymlinkOption\namber/deno/symlink SymlinkOption","url":"amber/deno/symlink.html#SymlinkOption"},{"doc":"amber/deno/symlink","title":"SymlinkType","content":"pub type SymlinkType {\n  File\n  Dir\n  Junction\n}\n\nFile\n\n\nDir\n\n\nJunction\n\n\nSynonyms:\namber/deno/symlink.SymlinkType\namber/deno/symlink SymlinkType","url":"amber/deno/symlink.html#SymlinkType"},{"doc":"amber/deno/symlink","title":"amber/deno/symlink","content":"","url":"amber/deno/symlink.html"},{"doc":"amber/deno/watch_fs","title":"WatchFsOption","content":"pub type WatchFsOption {\n  Recursive(Bool)\n}\n\nRecursive(Bool)\n\n\nSynonyms:\namber/deno/watch_fs.WatchFsOption\namber/deno/watch_fs WatchFsOption","url":"amber/deno/watch_fs.html#WatchFsOption"},{"doc":"amber/deno/watch_fs","title":"amber/deno/watch_fs","content":"","url":"amber/deno/watch_fs.html"},{"doc":"amber/deno/write_file","title":"WriteFileOption","content":"pub type WriteFileOption {\n  Append\n  Create(Bool)\n  CreateNew\n  Mode(Int)\n  Signal(AbortSignal)\n}\n\nAppend\n\n\nCreate(Bool)\n\n\nCreateNew\n\n\nMode(Int)\n\n\nSignal(AbortSignal)\n\n\nSynonyms:\namber/deno/write_file.WriteFileOption\namber/deno/write_file WriteFileOption","url":"amber/deno/write_file.html#WriteFileOption"},{"doc":"amber/deno/write_file","title":"amber/deno/write_file","content":"","url":"amber/deno/write_file.html"},{"doc":"amber/deno","title":"chmod_sync","content":"pub fn chmod_sync(path: String, mode: Int) -&gt; Nil\n\nSynonyms:\namber/deno.chmod_sync\namber/deno chmod_sync","url":"amber/deno.html#chmod_sync"},{"doc":"amber/deno","title":"chown_sync","content":"pub fn chown_sync(\n  path: String,\n  uid: Option(Int),\n  gid: Option(Int),\n) -&gt; Nil\n\nSynonyms:\namber/deno.chown_sync\namber/deno chown_sync","url":"amber/deno.html#chown_sync"},{"doc":"amber/deno","title":"copy_file_sync","content":"pub fn copy_file_sync(from_path: String, to_path: String) -&gt; Nil\n\nSynonyms:\namber/deno.copy_file_sync\namber/deno copy_file_sync","url":"amber/deno.html#copy_file_sync"},{"doc":"amber/deno","title":"create_sync","content":"pub fn create_sync(path: String) -&gt; Result(FsFile, Error)\n\nSynonyms:\namber/deno.create_sync\namber/deno create_sync","url":"amber/deno.html#create_sync"},{"doc":"amber/deno","title":"link_sync","content":"pub fn link_sync(\n  oldpath: String,\n  newpath: String,\n) -&gt; Result(Nil, Error)\n\nSynonyms:\namber/deno.link_sync\namber/deno link_sync","url":"amber/deno.html#link_sync"},{"doc":"amber/deno","title":"lstat_sync","content":"pub fn lstat_sync(path: String) -&gt; FileInfo\n\nSynonyms:\namber/deno.lstat_sync\namber/deno lstat_sync","url":"amber/deno.html#lstat_sync"},{"doc":"amber/deno","title":"make_temp_dir_sync","content":"pub fn make_temp_dir_sync(\n  options: List(MakeTempOption),\n) -&gt; String\n\nSynonyms:\namber/deno.make_temp_dir_sync\namber/deno make_temp_dir_sync","url":"amber/deno.html#make_temp_dir_sync"},{"doc":"amber/deno","title":"make_temp_file_sync","content":"pub fn make_temp_file_sync(\n  options: List(MakeTempOption),\n) -&gt; String\n\nSynonyms:\namber/deno.make_temp_file_sync\namber/deno make_temp_file_sync","url":"amber/deno.html#make_temp_file_sync"},{"doc":"amber/deno","title":"mkdir_sync","content":"pub fn mkdir_sync(\n  path: String,\n  options: List(MkdirOption),\n) -&gt; Nil\n\nSynonyms:\namber/deno.mkdir_sync\namber/deno mkdir_sync","url":"amber/deno.html#mkdir_sync"},{"doc":"amber/deno","title":"open_sync","content":"pub fn open_sync(\n  path: String,\n  options: List(OpenOption),\n) -&gt; Result(FsFile, Error)\n\nSynonyms:\namber/deno.open_sync\namber/deno open_sync","url":"amber/deno.html#open_sync"},{"doc":"amber/deno","title":"read_dir_sync","content":"pub fn read_dir_sync(path: String) -&gt; List(DirEntry)\n\nSynonyms:\namber/deno.read_dir_sync\namber/deno read_dir_sync","url":"amber/deno.html#read_dir_sync"},{"doc":"amber/deno","title":"read_file_sync","content":"pub fn read_file_sync(path: String) -&gt; Uint8Array\n\nSynonyms:\namber/deno.read_file_sync\namber/deno read_file_sync","url":"amber/deno.html#read_file_sync"},{"doc":"amber/deno","title":"read_link_sync","content":"pub fn read_link_sync(path: String) -&gt; String\n\nSynonyms:\namber/deno.read_link_sync\namber/deno read_link_sync","url":"amber/deno.html#read_link_sync"},{"doc":"amber/deno","title":"read_text_file_sync","content":"pub fn read_text_file_sync(path: String) -&gt; String\n\nSynonyms:\namber/deno.read_text_file_sync\namber/deno read_text_file_sync","url":"amber/deno.html#read_text_file_sync"},{"doc":"amber/deno","title":"real_path_sync","content":"pub fn real_path_sync(path: String) -&gt; String\n\nSynonyms:\namber/deno.real_path_sync\namber/deno real_path_sync","url":"amber/deno.html#real_path_sync"},{"doc":"amber/deno","title":"remove_sync","content":"pub fn remove_sync(\n  path: String,\n  options: List(RemoveOption),\n) -&gt; Nil\n\nSynonyms:\namber/deno.remove_sync\namber/deno remove_sync","url":"amber/deno.html#remove_sync"},{"doc":"amber/deno","title":"rename_sync","content":"pub fn rename_sync(oldpath: String, newpath: String) -&gt; Nil\n\nSynonyms:\namber/deno.rename_sync\namber/deno rename_sync","url":"amber/deno.html#rename_sync"},{"doc":"amber/deno","title":"set_umask","content":"pub fn set_umask(mask: Int) -&gt; Int\n\nSynonyms:\namber/deno.set_umask\namber/deno set_umask","url":"amber/deno.html#set_umask"},{"doc":"amber/deno","title":"stat_sync","content":"pub fn stat_sync(path: String) -&gt; FileInfo\n\nSynonyms:\namber/deno.stat_sync\namber/deno stat_sync","url":"amber/deno.html#stat_sync"},{"doc":"amber/deno","title":"symlink_sync","content":"pub fn symlink_sync(\n  oldpath: String,\n  newpath: String,\n  options: List(SymlinkOption),\n) -&gt; Nil\n\nSynonyms:\namber/deno.symlink_sync\namber/deno symlink_sync","url":"amber/deno.html#symlink_sync"},{"doc":"amber/deno","title":"truncate_sync","content":"pub fn truncate_sync(name: String, len: Option(Int)) -&gt; Nil\n\nSynonyms:\namber/deno.truncate_sync\namber/deno truncate_sync","url":"amber/deno.html#truncate_sync"},{"doc":"amber/deno","title":"umask","content":"pub fn umask() -&gt; Int\n\nSynonyms:\namber/deno.umask\namber/deno umask","url":"amber/deno.html#umask"},{"doc":"amber/deno","title":"utime_sync","content":"pub fn utime_sync(path: String, atime: Int, mtime: Int) -&gt; Nil\n\nSynonyms:\namber/deno.utime_sync\namber/deno utime_sync","url":"amber/deno.html#utime_sync"},{"doc":"amber/deno","title":"watch_fs","content":"pub fn watch_fs(\n  paths: List(String),\n  options: List(WatchFsOption),\n) -&gt; FsWatcher\n\nSynonyms:\namber/deno.watch_fs\namber/deno watch_fs","url":"amber/deno.html#watch_fs"},{"doc":"amber/deno","title":"write_file_sync","content":"pub fn write_file_sync(\n  path: String,\n  data: Uint8Array,\n  options: List(WriteFileOption),\n) -&gt; Nil\n\nSynonyms:\namber/deno.write_file_sync\namber/deno write_file_sync","url":"amber/deno.html#write_file_sync"},{"doc":"amber/deno","title":"write_text_file_sync","content":"pub fn write_text_file_sync(\n  path: String,\n  data: String,\n  options: List(WriteFileOption),\n) -&gt; Nil\n\nSynonyms:\namber/deno.write_text_file_sync\namber/deno write_text_file_sync","url":"amber/deno.html#write_text_file_sync"},{"doc":"amber/deno","title":"amber/deno","content":"","url":"amber/deno.html"},{"doc":"amber/deno/read_file","title":"ReadFileOption","content":"pub type ReadFileOption {\n  Signal(AbortSignal)\n}\n\nSignal(AbortSignal)\n\n\nSynonyms:\namber/deno/read_file.ReadFileOption\namber/deno/read_file ReadFileOption","url":"amber/deno/read_file.html#ReadFileOption"},{"doc":"amber/deno/read_file","title":"amber/deno/read_file","content":"","url":"amber/deno/read_file.html"},{"doc":"amber/web/encode_into_result","title":"EncodeIntoResult","content":"pub type EncodeIntoResult {\n  EncodeIntoResult(read: Int, written: Int)\n}\n\nEncodeIntoResult(read: Int, written: Int)\n\n\nSynonyms:\namber/web/encode_into_result.EncodeIntoResult\namber/web/encode_into_result EncodeIntoResult","url":"amber/web/encode_into_result.html#EncodeIntoResult"},{"doc":"amber/web/encode_into_result","title":"amber/web/encode_into_result","content":"","url":"amber/web/encode_into_result.html"},{"doc":"amber/web/iterator_result","title":"IteratorResult","content":"pub type IteratorResult(a, result) {\n  Yield(value: a)\n  Return(value: result)\n}\n\nYield(value: a)\n\n\nReturn(value: result)\n\n\nSynonyms:\namber/web/iterator_result.IteratorResult\namber/web/iterator_result IteratorResult","url":"amber/web/iterator_result.html#IteratorResult"},{"doc":"amber/web/iterator_result","title":"amber/web/iterator_result","content":"","url":"amber/web/iterator_result.html"},{"doc":"amber/web/iterator","title":"Iterator","content":"pub type Iterator(a, return, next)\n\n\nSynonyms:\namber/web/iterator.Iterator\namber/web/iterator Iterator","url":"amber/web/iterator.html#Iterator"},{"doc":"amber/web/iterator","title":"new","content":"pub fn new(\n  next: fn(Option(a)) -&gt; IteratorResult(b, c),\n) -&gt; Iterator(b, c, a)\n\nSynonyms:\namber/web/iterator.new\namber/web/iterator new","url":"amber/web/iterator.html#new"},{"doc":"amber/web/iterator","title":"next","content":"pub fn next(iterator: Iterator(a, b, c)) -&gt; IteratorResult(a, b)\n\nSynonyms:\namber/web/iterator.next\namber/web/iterator next","url":"amber/web/iterator.html#next"},{"doc":"amber/web/iterator","title":"next_with","content":"pub fn next_with(\n  iterator: Iterator(a, b, c),\n  value: c,\n) -&gt; IteratorResult(a, b)\n\nSynonyms:\namber/web/iterator.next_with\namber/web/iterator next_with","url":"amber/web/iterator.html#next_with"},{"doc":"amber/web/iterator","title":"return","content":"pub fn return(\n  iterator: Iterator(a, b, c),\n) -&gt; Result(IteratorResult(a, b), Nil)\n\nSynonyms:\namber/web/iterator.return\namber/web/iterator return","url":"amber/web/iterator.html#return"},{"doc":"amber/web/iterator","title":"return_with","content":"pub fn return_with(\n  iterator: Iterator(a, b, c),\n  value: b,\n) -&gt; Result(IteratorResult(a, b), Nil)\n\nSynonyms:\namber/web/iterator.return_with\namber/web/iterator return_with","url":"amber/web/iterator.html#return_with"},{"doc":"amber/web/iterator","title":"throw","content":"pub fn throw(\n  iterator: Iterator(a, b, c),\n  e: d,\n) -&gt; Result(IteratorResult(a, b), Nil)\n\nSynonyms:\namber/web/iterator.throw\namber/web/iterator throw","url":"amber/web/iterator.html#throw"},{"doc":"amber/web/iterator","title":"with_return","content":"pub fn with_return(\n  iterator: Iterator(a, b, c),\n  return: fn(Option(b)) -&gt; IteratorResult(a, b),\n) -&gt; Iterator(a, b, c)\n\nSynonyms:\namber/web/iterator.with_return\namber/web/iterator with_return","url":"amber/web/iterator.html#with_return"},{"doc":"amber/web/iterator","title":"with_throw","content":"pub fn with_throw(\n  iterator: Iterator(a, b, c),\n  throw: fn(d) -&gt; IteratorResult(a, b),\n) -&gt; Iterator(a, b, c)\n\nSynonyms:\namber/web/iterator.with_throw\namber/web/iterator with_throw","url":"amber/web/iterator.html#with_throw"},{"doc":"amber/web/iterator","title":"amber/web/iterator","content":"","url":"amber/web/iterator.html"},{"doc":"amber/web/promise_settled_result","title":"PromiseSettledResult","content":"pub type PromiseSettledResult(a) {\n  Fulfilled(value: a)\n  Rejected(reason: Dynamic)\n}\n\nFulfilled(value: a)\n\n\nRejected(reason: Dynamic)\n\n\nSynonyms:\namber/web/promise_settled_result.PromiseSettledResult\namber/web/promise_settled_result PromiseSettledResult","url":"amber/web/promise_settled_result.html#PromiseSettledResult"},{"doc":"amber/web/promise_settled_result","title":"amber/web/promise_settled_result","content":"","url":"amber/web/promise_settled_result.html"},{"doc":"amber/web/promise","title":"Promise","content":"pub type Promise(a)\n\n\nSynonyms:\namber/web/promise.Promise\namber/web/promise Promise","url":"amber/web/promise.html#Promise"},{"doc":"amber/web/promise","title":"PromiseWithResolvers","content":"pub type PromiseWithResolvers(a) {\n  PromiseWithResolvers(\n    promise: Promise(a),\n    resolve: fn(a) -&gt; Nil,\n    reject: fn(Dynamic) -&gt; Nil,\n  )\n}\n\nPromiseWithResolvers(\n  promise: Promise(a),\n  resolve: fn(a) -&gt; Nil,\n  reject: fn(Dynamic) -&gt; Nil,\n)\n\n\nSynonyms:\namber/web/promise.PromiseWithResolvers\namber/web/promise PromiseWithResolvers","url":"amber/web/promise.html#PromiseWithResolvers"},{"doc":"amber/web/promise","title":"all","content":"pub fn all(values: List(Promise(a))) -&gt; Promise(List(a))\n Creates a Promise that is resolved with a list of results when all of the\n provided Promises resolve, or rejected when any Promise is rejected.\n\nSynonyms:\namber/web/promise.all\namber/web/promise all","url":"amber/web/promise.html#all"},{"doc":"amber/web/promise","title":"all_settled","content":"pub fn all_settled(\n  values: List(Promise(a)),\n) -&gt; Promise(List(PromiseSettledResult(a)))\n Creates a Promise that is resolved with a list of `PromiseSettledResult`s\n when all of the provided Promises resolve or reject.\n\nSynonyms:\namber/web/promise.all_settled\namber/web/promise all_settled","url":"amber/web/promise.html#all_settled"},{"doc":"amber/web/promise","title":"any","content":"pub fn any(values: List(Promise(a))) -&gt; Promise(a)\n Returns a promise that is fulfilled by the first given promise to be\n fulfilled, or rejected with an AggregateError containing a list of\n rejection reasons if all of the given promises are rejected.\n\nSynonyms:\namber/web/promise.any\namber/web/promise any","url":"amber/web/promise.html#any"},{"doc":"amber/web/promise","title":"catch","content":"pub fn catch(\n  promise: Promise(a),\n  onrejected: fn(b) -&gt; Nil,\n) -&gt; Promise(a)\n Attaches a callback for the rejection of the Promise.\n\nSynonyms:\namber/web/promise.catch\namber/web/promise catch","url":"amber/web/promise.html#catch"},{"doc":"amber/web/promise","title":"finally","content":"pub fn finally(\n  promise: Promise(a),\n  onfinally: fn() -&gt; Nil,\n) -&gt; Promise(a)\n Attaches a callback that is invoked when the Promise is settled\n (fulfilled or rejected). The resolved value cannot be modified from the\n callback.\n\nSynonyms:\namber/web/promise.finally\namber/web/promise finally","url":"amber/web/promise.html#finally"},{"doc":"amber/web/promise","title":"new","content":"pub fn new(\n  executor: fn(fn(a) -&gt; Nil, fn(b) -&gt; Nil) -&gt; Nil,\n) -&gt; Promise(a)\n Creates a new Promise.\n The executor callback is passed two arguments: a resolve callback used to\n resolve the promise with a value, and a reject callback used to reject the\n promise with a provided reason or error.\n\nSynonyms:\namber/web/promise.new\namber/web/promise new","url":"amber/web/promise.html#new"},{"doc":"amber/web/promise","title":"race","content":"pub fn race(values: List(Promise(a))) -&gt; Promise(a)\n Creates a Promise that is resolved or rejected when any of the provided\n Promises are resolved or rejected.\n\nSynonyms:\namber/web/promise.race\namber/web/promise race","url":"amber/web/promise.html#race"},{"doc":"amber/web/promise","title":"reject","content":"pub fn reject(reason: a) -&gt; Promise(b)\n Creates a new rejected promise for the provided reason.\n\nSynonyms:\namber/web/promise.reject\namber/web/promise reject","url":"amber/web/promise.html#reject"},{"doc":"amber/web/promise","title":"resolve","content":"pub fn resolve(value: a) -&gt; Promise(a)\n Creates a new resolved promise for the provided value.\n\nSynonyms:\namber/web/promise.resolve\namber/web/promise resolve","url":"amber/web/promise.html#resolve"},{"doc":"amber/web/promise","title":"then","content":"pub fn then(\n  promise: Promise(a),\n  onfulfilled: fn(a) -&gt; b,\n) -&gt; Promise(b)\n Attaches a callback for the resolution of the Promise.\n\nSynonyms:\namber/web/promise.then\namber/web/promise then","url":"amber/web/promise.html#then"},{"doc":"amber/web/promise","title":"with_resolvers","content":"pub fn with_resolvers() -&gt; PromiseWithResolvers(a)\n Creates a new Promise and returns it in a `PromiseWithResolvers` record,\n along with its resolve and reject functions.\n\nSynonyms:\namber/web/promise.with_resolvers\namber/web/promise with_resolvers","url":"amber/web/promise.html#with_resolvers"},{"doc":"amber/web/promise","title":"amber/web/promise","content":"","url":"amber/web/promise.html"},{"doc":"amber/web/text_decode_option","title":"TextDecodeOption","content":"pub type TextDecodeOption {\n  Stream\n}\n\nStream\n\n\nSynonyms:\namber/web/text_decode_option.TextDecodeOption\namber/web/text_decode_option TextDecodeOption","url":"amber/web/text_decode_option.html#TextDecodeOption"},{"doc":"amber/web/text_decode_option","title":"amber/web/text_decode_option","content":"","url":"amber/web/text_decode_option.html"},{"doc":"amber/web/text_decoder_option","title":"TextDecoderOption","content":"pub type TextDecoderOption {\n  Fatal\n  IgnoreBom\n}\n\nFatal\n Indicates that [`decode`](./text_decoder.html#decode) must throw a\n TypeError when decoding invalid data. It defaults to false, which means\n that the decoder will substitute malformed data with a replacement\n character.\n\n\nIgnoreBom\n Indicates whether the [byte order mark](https://www.w3.org/International/questions/qa-byte-order-mark)\n will be included in the output or skipped over. It defaults to false,\n which means that the byte order mark will be skipped over when decoding\n and will not be included in the decoded text.\n\n\nSynonyms:\namber/web/text_decoder_option.TextDecoderOption\namber/web/text_decoder_option TextDecoderOption","url":"amber/web/text_decoder_option.html#TextDecoderOption"},{"doc":"amber/web/text_decoder_option","title":"amber/web/text_decoder_option","content":"","url":"amber/web/text_decoder_option.html"},{"doc":"amber/web/text_decoder","title":"TextDecoder","content":"pub type TextDecoder\n Represents a decoder for a specific text encoding, allowing you to convert\n binary data into a string given the encoding.\n\n ## Examples\n\n \n let decoder = text_decoder.new_with(&quot;utf-8&quot;, [])\n let buffer = uint8_array.from_list([72, 101, 108, 108, 111])\n let decoded_string =\n   decoder |&gt; text_decoder.decode_with(buffer |&gt; uint8_array.buffer, [])\n io.debug(decoded_string)\n // =&gt; Outputs: &quot;Hello&quot;\n \n\n\nSynonyms:\namber/web/text_decoder.TextDecoder\namber/web/text_decoder TextDecoder","url":"amber/web/text_decoder.html#TextDecoder"},{"doc":"amber/web/text_decoder","title":"decode","content":"pub fn decode(decoder: TextDecoder) -&gt; String\n Turns binary data, often in the form of a Uint8Array, into a string given\n the encoding.\n\nSynonyms:\namber/web/text_decoder.decode\namber/web/text_decoder decode","url":"amber/web/text_decoder.html#decode"},{"doc":"amber/web/text_decoder","title":"decode_with","content":"pub fn decode_with(\n  decoder: TextDecoder,\n  input: ArrayBuffer,\n  options: List(TextDecodeOption),\n) -&gt; String\n\nSynonyms:\namber/web/text_decoder.decode_with\namber/web/text_decoder decode_with","url":"amber/web/text_decoder.html#decode_with"},{"doc":"amber/web/text_decoder","title":"new","content":"pub fn new() -&gt; TextDecoder\n\nSynonyms:\namber/web/text_decoder.new\namber/web/text_decoder new","url":"amber/web/text_decoder.html#new"},{"doc":"amber/web/text_decoder","title":"new_with","content":"pub fn new_with(\n  label: String,\n  options: List(TextDecoderOption),\n) -&gt; TextDecoder\n\nSynonyms:\namber/web/text_decoder.new_with\namber/web/text_decoder new_with","url":"amber/web/text_decoder.html#new_with"},{"doc":"amber/web/text_decoder","title":"amber/web/text_decoder","content":"","url":"amber/web/text_decoder.html"},{"doc":"amber/web/text_encoder","title":"TextEncoder","content":"pub type TextEncoder\n Allows you to convert a string into binary data\n (in the form of a Uint8Array) given the encoding.\n\n ## Examples\n\n \n import amber/web/text_encoder\n\n text_encoder.new()\n |&gt; text_encoder.encode(&quot;Hello&quot;)\n // -&gt; //js(Uint8Array { &quot;0&quot;: 72, &quot;1&quot;: 101, &quot;2&quot;: 108, &quot;3&quot;: 108, &quot;4&quot;: 111 })\n \n\n\nSynonyms:\namber/web/text_encoder.TextEncoder\namber/web/text_encoder TextEncoder","url":"amber/web/text_encoder.html#TextEncoder"},{"doc":"amber/web/text_encoder","title":"encode","content":"pub fn encode(encoder: TextEncoder, input: String) -&gt; Uint8Array\n Turns a string into binary data (in the form of a Uint8Array) using UTF-8\n encoding.\n\nSynonyms:\namber/web/text_encoder.encode\namber/web/text_encoder encode","url":"amber/web/text_encoder.html#encode"},{"doc":"amber/web/text_encoder","title":"encode_into","content":"pub fn encode_into(\n  encoder: TextEncoder,\n  input: String,\n  dest: Uint8Array,\n) -&gt; EncodeIntoResult\n Encodes a string into the destination Uint8Array and returns the result of\n the encoding.\n\nSynonyms:\namber/web/text_encoder.encode_into\namber/web/text_encoder encode_into","url":"amber/web/text_encoder.html#encode_into"},{"doc":"amber/web/text_encoder","title":"new","content":"pub fn new() -&gt; TextEncoder\n\nSynonyms:\namber/web/text_encoder.new\namber/web/text_encoder new","url":"amber/web/text_encoder.html#new"},{"doc":"amber/web/text_encoder","title":"amber/web/text_encoder","content":"","url":"amber/web/text_encoder.html"}]);